import 'package:flutter/widgets.dart';
import 'package:keyboard_utils/keyboard_listener.dart';
import 'package:keyboard_utils/keyboard_utils.dart';

mixin KeyboardUtilsMixin<W extends StatefulWidget> on State<W> {
  KeyboardUtils _keyboardUtils = KeyboardUtils();
  KeyboardUtils get keyboardUtils => _keyboardUtils;

  int _keyboardSubscriptionId;

  @override
  void initState() {
    super.initState();
    _keyboardSubscriptionId = _keyboardUtils.add(listener: keyboardListener);
  }

  @override
  void dispose() {
    _keyboardUtils.unsubscribeListener(subscribingId: _keyboardSubscriptionId);
    if (_keyboardUtils.canCallDispose()) {
      _keyboardUtils.dispose();
    }
    super.dispose();
  }

  KeyboardListener get keyboardListener => KeyboardListener();
}
